#include <iostream>
#include <vector>
#include <algorithm>  //  std::min  std::max (    )

using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input
input_data() {
    Input in;

    cerr << "Enter number count: ";
    size_t number_count;
    cin >> number_count;

    in.numbers.resize(number_count);
    for (size_t i = 0; i < number_count; i++) {
        cin >> in.numbers[i];
    }

    cerr << "Enter number bin: ";
    cin >> in.bin_count;

    return in;
}

void
find_minmax(const vector<double>& numbers, double& min, double& max) {
    min = numbers[0];
    max = numbers[0];
    for (double x : numbers) {
        if (x < min) {
            min = x;
        }
        if (x > max) {
            max = x;
        }
    }
}

vector<size_t>
make_histogram(const vector<double>& numbers, size_t bin_count) {
    double min, max;
    find_minmax(numbers, min, max);

    vector<size_t> bins(bin_count);
    double bin_size = (max - min) / bin_count;

    for (size_t i = 0; i < numbers.size(); i++) {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++) {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi)) {
                bins[j]++;
                found = true;
            }
        }
        if (!found) {
            bins[bin_count - 1]++;
        }
    }
    return bins;
}

void
show_histogram_text(const vector<size_t>& bins, size_t max_count, size_t MAX_ASTERISK) { //  bin_count ..  bins.size()

    for (size_t i = 0; i < bins.size(); i++) {
        if (bins[i] < 10) {
            cout << "  " << bins[i] << "|";
        } else if (bins[i] < 100) {
            cout << " " << bins[i] << "|";
        } else if (bins[i] < 1000) {
            cout << bins[i] << "|";
        }

        size_t height;

        if (max_count <= MAX_ASTERISK) {
            height = bins[i];
        } else {
            height = MAX_ASTERISK * (static_cast<double>(bins[i]) / max_count);
        }
        for (size_t j = 0; j < height; j++) {
            cout << "*";
        }
        cout << endl;
    }
}

int
main() {
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;

    auto in = input_data();
    auto bins = make_histogram(in.numbers, in.bin_count);

    size_t max_count = bins[0];
    for (size_t i = 0; i < bins.size(); i++) { //    bins.size()
        if (bins[i] > max_count) {
            max_count = bins[i];
        }
    }
    show_histogram_text(bins, max_count, MAX_ASTERISK);

    return 0;
}
